/*#include <Ticker.h>*/
#include <WiFi.h>
#include "SPIFFS.h"
#include "FS.h"
#include <lvgl.h>
#include <TFT_eSPI.h>
TFT_eSPI tft = TFT_eSPI(); /* TFT instance */
/* #define LVGL_TICK_PERIOD 20*/
/* display buffer https://docs.lvgl.io/latest/en/html/porting/display.html */
/*#define LVGL_TICK_PERIOD 20
  Ticker tick; // timer for interrupt handler
  SemaphoreHandle_t xSemaphore = NULL;*/
static lv_style_t style_kb;
static lv_disp_buf_t disp_buf;
static uint8_t BMPHeader[128];
int8_t NumeroNetwork = 0;
int Connessione = 1;
char TT[1024];
String T;
int BytesWrites = 0;
String command;
int incomingByte = 0;
File pFileOut;
/* LVGL objects */
static lv_obj_t * kb;
static lv_obj_t * kb_ta;
static lv_obj_t * Screen1;
static lv_obj_t * Sfondo1;
static lv_obj_t * LabelToast;
static lv_obj_t * Slider1;
static lv_obj_t * RollerSSID;
static lv_obj_t * LabelWIFI;
static lv_obj_t * LabelPREF;
static lv_obj_t * LabelSSID;
static lv_obj_t * LabelPASSW;
static lv_obj_t * LabelSlider;

int screenWidth = 480U;
int  screenHeight = 320U;
static lv_color_t buf[LV_HOR_RES_MAX * LV_VER_RES_MAX / 10];
/*static void lv_tick_handler(void) {
  lv_tick_inc(LVGL_TICK_PERIOD);
  }*/
/* ====================     Display flushing      Display flushing     Display flushing     Display flushing   ========================*/
void my_disp_flush(lv_disp_drv_t *disp, const lv_area_t *area, lv_color_t *color_p) {
  uint16_t c;
  tft.startWrite(); /* Start new TFT transaction */
  tft.setAddrWindow(area->x1, area->y1, (area->x2 - area->x1 + 1), (area->y2 - area->y1 + 1)); /* set the working window */
  for (int y = area->y1; y <= area->y2; y++) {
    for (int x = area->x1; x <= area->x2; x++) {
      c = color_p->full; tft.writeColor(c, 1); color_p++;
    }
  }
  tft.endWrite(); /* terminate TFT transaction */
  lv_disp_flush_ready(disp); /* tell lvgl that flushing is done */
}
/* =====================   READ TOUCHPAD ========================= */
bool my_input_read(lv_indev_drv_t * indev_driver, lv_indev_data_t * data) {
  uint16_t touchX, touchY;
  bool touched = tft.getTouch(&touchX, &touchY, 600);
  if (!touched) {
    return false;
  }
  if (touchX > screenWidth || touchY > screenHeight) {
  } else {
    data->state = touched ? LV_INDEV_STATE_PR : LV_INDEV_STATE_REL;
    data->point.x = touchX;
    data->point.y = touchY;
  }
  return false; /*Return `false` because we are not buffering and no more data to read*/
}
static void Slider1_eventhandler(lv_obj_t * obj, lv_event_t event) {/*     SLIDER1 EVENT    */
  if (event == LV_EVENT_VALUE_CHANGED) {
    int slid = lv_slider_get_value(Slider1);
    ledcWrite(0, slid); /* change the Brightnes of screen */
  }
}
static void LabelToast_eventhandler(lv_obj_t * obj, lv_event_t event) {/*     LABEL TOAST INFO EVENT    */
  if (event == LV_EVENT_PRESSED) {
    lv_obj_set_hidden(LabelToast, true);
  }
}
static void LabelWIFI_eventhandler(lv_obj_t * obj, lv_event_t event) { /*     WIFI LABEL BUTTON EVENT    */
  if (event == LV_EVENT_CLICKED) {
    if ( Connessione == 1) {
      lv_obj_set_hidden(LabelToast, false);
      lv_obj_set_hidden(LabelSSID, true);
      lv_obj_set_hidden(LabelPASSW, true);
      if (NumeroNetwork == 0) {
        lv_label_set_text(LabelToast, "No networks found"); lv_label_refr_text(LabelToast);
        Serial.println("no networks found");
        /*ESP.restart(); RESET*/
      } else {
        T = String(NumeroNetwork); T += "   Networks found";
        TT[(T.length() + 1)];
        T.toCharArray(TT, T.length() + 1);
        lv_label_set_text(LabelToast, TT); lv_obj_align(LabelToast, Screen1, LV_ALIGN_IN_TOP_MID, 0, 10); lv_label_refr_text(LabelToast);
        T = "";
        for (int i = 0; i < NumeroNetwork; ++i) {
          if (WiFi.RSSI(i) >= -70 && WiFi.RSSI(i) != 0) {/* i limit networks dispayed on Roller only if is from 0 to -70 */
            T += String(WiFi.SSID(i)); T += "   "; T += String( WiFi.RSSI(i)); T += "\n";
          }
        }
        TT[(T.length() + 1)];
        T.toCharArray(TT, T.length() + 1);
        Serial.print("TT Lenght = "); Serial.println((String)T.length());
        lv_roller_set_options(RollerSSID, TT, LV_ROLLER_MODE_NORMAL);
        lv_obj_align(RollerSSID, Screen1, LV_ALIGN_CENTER, 0, 0);
        lv_obj_set_hidden(RollerSSID, false);
        /* ESP.restart();*/
      }
    }
  }
}
static void LabelPASSW_eventhandler(lv_obj_t * obj, lv_event_t event) { /*     PASSW BUTTON EVENT    */
  if (event == LV_EVENT_PRESSED) {
    T = "Connection Start";
    TT[(T.length() + 1)];
    T.toCharArray(TT, T.length() + 1);
    lv_label_set_text(LabelToast, TT); lv_obj_align(LabelToast, Screen1, LV_ALIGN_IN_TOP_MID, 0, 10); lv_label_refr_text(LabelToast);
    lv_obj_set_hidden(LabelPASSW, true);
    lv_obj_set_hidden(LabelSSID, true);
  }
}
static void LabelPREF_eventhandler(lv_obj_t * obj, lv_event_t event) { /*     PREF BUTTON EVENT    */
  if (event == LV_EVENT_PRESSED) {
    lv_obj_set_hidden(LabelToast, true);
  }
}
static void RollerSSID_eventhandler(lv_obj_t * obj, lv_event_t event) {
  if (event == LV_EVENT_LONG_PRESSED) {
    lv_label_set_text(LabelToast, "Select a Password now"); lv_obj_align(LabelToast, Screen1, LV_ALIGN_IN_TOP_MID, 0, 10); lv_label_refr_text(LabelToast);
    T = "";
    T = String(WiFi.SSID(lv_roller_get_selected(RollerSSID)));
    if (T != "") {
      TT[(T.length() + 1)];
      T.toCharArray(TT, T.length() + 1);
      lv_label_set_text(LabelSSID, TT);
      lv_obj_align(LabelSSID, Screen1, LV_ALIGN_CENTER, -138, -90); lv_label_refr_text(LabelSSID);
      lv_obj_set_hidden(LabelSSID, false);
      lv_obj_set_hidden(LabelPASSW, false);
      lv_obj_set_hidden(RollerSSID, true);
      lv_obj_set_hidden(kb_ta, false);
      lv_obj_set_hidden(kb, false);
    } else {
      lv_label_set_text(LabelToast, "Wrong selection"); lv_obj_align(LabelToast, Screen1, LV_ALIGN_IN_TOP_MID, 0, 10); lv_label_refr_text(LabelToast);
    }
  }
}
/* -----------  KEYBOARD EVENT  --------------*/
static void keyboard_event_cb(lv_obj_t * kb, lv_event_t event) {
  lv_keyboard_def_event_cb(kb, event);
  if (event == LV_EVENT_APPLY) {
    lv_obj_set_hidden(kb_ta, true);
    lv_obj_set_hidden(kb, true);
    updatePassw( lv_textarea_get_text(kb_ta));
    lv_textarea_set_text(kb_ta, "");
  } else if (event == LV_EVENT_CANCEL) {
    lv_obj_set_hidden(kb_ta, true);
    lv_obj_set_hidden(kb, true);
  }
}
#if USE_LV_LOG != 0
/* Serial debugging */
void my_print(lv_log_level_t level, const char * file, uint32_t line, const char * dsc) {
  Serial.printf("%s@%d->%s\r\n", file, line, dsc);
  Serial.flush();
}
#endif
/* ==========================    SETUP     SETUP      SETUP       SETUP         SETUP             SETUP  ====================== */
void setup() {
  ledcSetup(0, 5000/*freq*/, 10 /*resolution*/);
  ledcAttachPin(32, 0);/* PWM on Pin 32 if connected */
  ledcWrite(0, 128); // Start @ initial Brightnes (0-255)
  Serial.begin(115200); /* prepare for possible serial debug */
  //Serial.begin(250000); /* prepare for possible serial debug */
  //Serial.flush();
  delay(100);
  WiFi.mode(WIFI_STA);
  WiFi.disconnect();
  delay(100);
  NumeroNetwork = WiFi.scanNetworks();
  delay(1000);
  if (SPIFFS.begin()) {
    Serial.println(F("SPIFFS mounted correctly."));
  } else {
    Serial.println(F("!An error occurred during SPIFFS mounting"));
  }
  lv_init();
  tft.begin(); /* TFT init */
  tft.setRotation(3);
  uint16_t calData[5] = { 275, 3620, 264, 3532, 1 };
  tft.setTouch(calData);
  lv_disp_buf_init(&disp_buf, buf, NULL, LV_HOR_RES_MAX * LV_VER_RES_MAX / 10);
  /*Initialize the DISPLAY*/
  lv_disp_drv_t disp_drv;
  lv_disp_drv_init(&disp_drv);
  disp_drv.hor_res = screenWidth;
  disp_drv.ver_res = screenHeight;
  disp_drv.flush_cb = my_disp_flush;
  disp_drv.buffer = &disp_buf;
  lv_disp_drv_register(&disp_drv);
  /*Initialize the INPUT DEVICE DRIVER*/
  lv_indev_drv_t indev_drv;
  lv_indev_drv_init(&indev_drv);      /*Basic initialization*/
  indev_drv.type = LV_INDEV_TYPE_POINTER;   /*Touch pad is a pointer-like device*/
  indev_drv.read_cb = my_input_read;
  /*Register the driver in LVGL and save the created input device object*/
  lv_indev_drv_register(&indev_drv);
  /*tick.attach_ms(LVGL_TICK_PERIOD, lv_tick_handler);
    xSemaphore = xSemaphoreCreateMutex(); //mutex to handle the processes*/
#if USE_LV_LOG != 0
  lv_log_register_print_cb(my_print); /* register print function for debugging */
#endif

  Screen1 = lv_obj_create(NULL, NULL);/*-------------------------- SCREEN1 ----------------------------*/
  lv_disp_load_scr(Screen1);/*  <<<<<<<<<<  IMPORTANT IMPORTANT IMPORTANT IMPORTANT IMPORTANT IMPORTANT ------------*/
  Sfondo1 = lv_obj_create(Screen1, NULL);/*-------------------------- SFONDO1 BACKGROUND----------------------------*/
  lv_obj_set_click(Sfondo1, false);
  lv_obj_set_hidden(Sfondo1, false);
  lv_obj_clear_state(Sfondo1, LV_STATE_DISABLED);
  lv_obj_set_size(Sfondo1, 480, 320);  // force: 0
  lv_obj_align(Sfondo1, Screen1, LV_ALIGN_CENTER, 0, 0); // force: 480
  lv_obj_set_drag(Sfondo1, false);
  lv_obj_set_style_local_bg_color(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(48 * 256 * 256 + 169 * 256 + 192));
  lv_obj_set_style_local_bg_opa(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_bg_grad_color(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(6 * 256 * 256 + 38 * 256 + 52));
  lv_obj_set_style_local_bg_main_stop(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 0);
  lv_obj_set_style_local_bg_grad_stop(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 320);
  lv_obj_set_style_local_radius(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 50);
  lv_obj_set_style_local_bg_grad_dir(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_GRAD_DIR_VER);
  lv_obj_set_style_local_border_color(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
  lv_obj_set_style_local_border_opa(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_border_width(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 2);
  lv_obj_set_style_local_border_side(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_BORDER_SIDE_FULL);
  lv_obj_set_style_local_shadow_color(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
  lv_obj_set_style_local_shadow_opa(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_shadow_width(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 60);
  lv_obj_set_style_local_shadow_spread(Sfondo1, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);

  /*FONT_SMALL  montserrat_12      FONT_NORMAL montserrat_14    FONT_SUBTITLE montserrat_20   FONT_TITLE montserrat_24*/
  Slider1 = lv_slider_create(Screen1, NULL);/*-------------------------- SLIDER1 ----------------------------*/
  lv_obj_set_size(Slider1, 128, 5);/*  WIDE,HEIGHT   */
  lv_obj_align(Slider1, Screen1, LV_ALIGN_CENTER, 0, 130);
  lv_slider_set_range(Slider1, 0, 255);/*  SLIDER RANGE   */
  lv_slider_set_type(Slider1, LV_SLIDER_TYPE_NORMAL);
  lv_slider_set_value(Slider1, 128, LV_ANIM_OFF);/*  START POSITION half brightness   */
  lv_slider_set_left_value(Slider1, 0, LV_ANIM_OFF);
  lv_obj_set_click(Slider1, true);
  lv_obj_set_hidden(Slider1, false);
  lv_obj_clear_state(Slider1, LV_STATE_DISABLED);
  lv_obj_set_drag(Slider1, false);
  lv_obj_set_style_local_bg_color(Slider1, LV_SLIDER_PART_BG, LV_STATE_DEFAULT, lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
  lv_obj_set_style_local_bg_opa(Slider1, LV_SLIDER_PART_BG, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_bg_grad_color(Slider1, LV_SLIDER_PART_BG, LV_STATE_DEFAULT, lv_color_hex(248 * 256 * 256 + 255 * 256 + 190));
  lv_obj_set_style_local_bg_main_stop(Slider1, LV_SLIDER_PART_BG, LV_STATE_DEFAULT, 50);
  lv_obj_set_style_local_bg_grad_stop(Slider1, LV_SLIDER_PART_BG, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_radius(Slider1, LV_SLIDER_PART_BG, LV_STATE_DEFAULT, 5);
  lv_obj_set_style_local_bg_grad_dir(Slider1, LV_SLIDER_PART_BG, LV_STATE_DEFAULT, LV_GRAD_DIR_HOR);
  lv_obj_set_style_local_shadow_color(Slider1, LV_SLIDER_PART_BG, LV_STATE_DEFAULT, lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
  lv_obj_set_style_local_shadow_opa(Slider1, LV_SLIDER_PART_BG, LV_STATE_DEFAULT, 200);
  lv_obj_set_style_local_shadow_width(Slider1, LV_SLIDER_PART_BG, LV_STATE_DEFAULT, 40);
  lv_obj_set_style_local_shadow_spread(Slider1, LV_SLIDER_PART_BG, LV_STATE_DEFAULT, 8);
  lv_obj_set_style_local_bg_color(Slider1, LV_SLIDER_PART_INDIC, LV_STATE_DEFAULT, lv_color_hex(11 * 256 * 256 + 12 * 256 + 12));
  lv_obj_set_style_local_bg_opa(Slider1, LV_SLIDER_PART_INDIC, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_bg_grad_color(Slider1, LV_SLIDER_PART_INDIC, LV_STATE_DEFAULT, lv_color_hex(194 * 256 * 256 + 198 * 256 + 0));
  lv_obj_set_style_local_bg_main_stop(Slider1, LV_SLIDER_PART_INDIC, LV_STATE_DEFAULT, 0);
  lv_obj_set_style_local_bg_grad_stop(Slider1, LV_SLIDER_PART_INDIC, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_radius(Slider1, LV_SLIDER_PART_INDIC, LV_STATE_DEFAULT, 10);
  lv_obj_set_style_local_bg_grad_dir(Slider1, LV_SLIDER_PART_INDIC, LV_STATE_DEFAULT, LV_GRAD_DIR_HOR);
  lv_obj_set_style_local_outline_color(Slider1, LV_SLIDER_PART_INDIC, LV_STATE_DEFAULT, lv_color_hex(254 * 256 * 256 + 255 * 256 + 227));
  lv_obj_set_style_local_outline_opa(Slider1, LV_SLIDER_PART_INDIC, LV_STATE_DEFAULT, 100);
  lv_obj_set_style_local_outline_width(Slider1, LV_SLIDER_PART_INDIC, LV_STATE_DEFAULT, 1);
  lv_obj_set_style_local_outline_pad(Slider1, LV_SLIDER_PART_INDIC, LV_STATE_DEFAULT, 1);
  lv_obj_set_style_local_bg_color(Slider1, LV_SLIDER_PART_KNOB, LV_STATE_DEFAULT, lv_color_hex(19 * 256 * 256 + 77 * 256 + 15));
  lv_obj_set_style_local_bg_opa(Slider1, LV_SLIDER_PART_KNOB, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_bg_grad_color(Slider1, LV_SLIDER_PART_KNOB, LV_STATE_DEFAULT, lv_color_hex(150 * 256 * 256 + 253 * 256 + 143));
  lv_obj_set_style_local_bg_grad_dir(Slider1, LV_SLIDER_PART_KNOB, LV_STATE_DEFAULT, LV_GRAD_DIR_HOR);
  lv_obj_set_style_local_shadow_color(Slider1, LV_SLIDER_PART_KNOB, LV_STATE_DEFAULT, lv_color_hex(128 * 256 * 256 + 203 * 256 + 157));
  lv_obj_set_style_local_shadow_opa(Slider1, LV_SLIDER_PART_KNOB, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_shadow_width(Slider1, LV_SLIDER_PART_KNOB, LV_STATE_DEFAULT, 40);
  lv_obj_set_style_local_shadow_spread(Slider1, LV_SLIDER_PART_KNOB, LV_STATE_DEFAULT, 10);
  lv_obj_set_style_local_pad_left(Slider1, LV_SLIDER_PART_KNOB, LV_STATE_DEFAULT, 8);
  lv_obj_set_style_local_pad_right(Slider1, LV_SLIDER_PART_KNOB, LV_STATE_DEFAULT, 8);
  lv_obj_set_style_local_pad_top(Slider1, LV_SLIDER_PART_KNOB, LV_STATE_DEFAULT, 2);
  lv_obj_set_style_local_pad_bottom(Slider1, LV_SLIDER_PART_KNOB, LV_STATE_DEFAULT, 2);
  lv_obj_set_event_cb(Slider1, Slider1_eventhandler);/*Assign an event function*/

  /*FONT_SMALL  montserrat_12      FONT_NORMAL montserrat_14    FONT_SUBTITLE montserrat_20   FONT_TITLE montserrat_24*/
  LabelToast = lv_label_create(Screen1, NULL);/*-------------------------- LABEL INFO TOAST ----------------------------*/
  lv_label_set_long_mode(LabelToast, LV_LABEL_LONG_EXPAND);
  lv_label_set_align(LabelToast, LV_LABEL_ALIGN_CENTER);
  lv_label_set_text(LabelToast, "Info Text  click for close");
  lv_obj_set_size(LabelToast, 180, 22);  // force: 0
  lv_obj_set_click(LabelToast, true);
  lv_obj_set_hidden(LabelToast, false);
  lv_obj_clear_state(LabelToast, LV_STATE_DISABLED);
  lv_obj_set_drag(LabelToast, false);
  lv_obj_set_style_local_text_color(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(255 * 256 * 256 + 255 * 256 + 255));
  lv_obj_set_style_local_text_opa(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_text_font(LabelToast, LV_LABEL_PART_MAIN, LV_STATE_DEFAULT, LV_THEME_DEFAULT_FONT_SMALL);
  lv_obj_set_style_local_bg_color(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(103 * 256 * 256 + 139 * 256 + 156));
  lv_obj_set_style_local_bg_opa(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_bg_grad_color(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(21 * 256 * 256 + 32 * 256 + 38));
  lv_obj_set_style_local_bg_main_stop(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 0);
  lv_obj_set_style_local_bg_grad_stop(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_radius(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
  lv_obj_set_style_local_bg_grad_dir(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_GRAD_DIR_VER);
  lv_obj_set_style_local_shadow_color(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
  lv_obj_set_style_local_shadow_opa(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 200);
  lv_obj_set_style_local_shadow_width(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 30);
  lv_obj_set_style_local_shadow_spread(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 5);
  lv_obj_set_style_local_pad_left(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 9);
  lv_obj_set_style_local_pad_right(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 9);
  lv_obj_set_style_local_pad_top(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 6);
  lv_obj_set_style_local_pad_bottom(LabelToast, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 6);
  lv_obj_align(LabelToast, Screen1, LV_ALIGN_IN_TOP_MID, 0, 10); // force: 260
  lv_obj_set_event_cb(LabelToast, LabelToast_eventhandler);/*Assign an event function*/

  /*FONT_SMALL  montserrat_12      FONT_NORMAL montserrat_14    FONT_SUBTITLE montserrat_20   FONT_TITLE montserrat_24*/
  LabelWIFI = lv_label_create(Screen1, NULL);/*-------------------------- LABEL WIFI ----------------------------*/
  lv_label_set_long_mode(LabelWIFI, LV_LABEL_LONG_CROP);
  lv_label_set_align(LabelWIFI, LV_LABEL_ALIGN_CENTER);
  lv_label_set_text(LabelWIFI, "WIFI\n");
  lv_obj_set_size(LabelWIFI, 88, 40);  // force: -138
  lv_obj_set_click(LabelWIFI, true);
  lv_obj_set_hidden(LabelWIFI, false);
  if (NumeroNetwork == 0) {
    lv_obj_set_state(LabelWIFI, LV_STATE_DISABLED);
  }
  lv_obj_set_drag(LabelWIFI, false);
  lv_obj_set_style_local_text_color(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(252 * 256 * 256 + 252 * 256 + 252));
  lv_obj_set_style_local_text_opa(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 150);
  lv_obj_set_style_local_text_font(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_THEME_DEFAULT_FONT_SUBTITLE);
  lv_obj_set_style_local_bg_color(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(45 * 256 * 256 + 160 * 256 + 183));
  lv_obj_set_style_local_bg_opa(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_bg_grad_color(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(10 * 256 * 256 + 19 * 256 + 24));
  lv_obj_set_style_local_bg_main_stop(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 30);
  lv_obj_set_style_local_bg_grad_stop(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 128);
  lv_obj_set_style_local_radius(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 20);
  lv_obj_set_style_local_bg_grad_dir(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_GRAD_DIR_VER);
  lv_obj_set_style_local_border_color(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
  lv_obj_set_style_local_border_opa(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_border_width(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 1);
  lv_obj_set_style_local_border_side(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_BORDER_SIDE_FULL);
  lv_obj_set_style_local_shadow_color(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
  lv_obj_set_style_local_shadow_opa(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 200);
  lv_obj_set_style_local_shadow_width(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 40);
  lv_obj_set_style_local_shadow_spread(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 5);
  lv_obj_set_style_local_pad_left(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
  lv_obj_set_style_local_pad_right(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
  lv_obj_set_style_local_pad_top(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
  lv_obj_set_style_local_pad_bottom(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
  lv_obj_set_style_local_text_color(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_PRESSED, lv_color_hex(254 * 256 * 256 + 253 * 256 + 206));
  lv_obj_set_style_local_text_opa(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 255);
  lv_obj_set_style_local_text_font(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_PRESSED, LV_THEME_DEFAULT_FONT_SUBTITLE);
  lv_obj_set_style_local_shadow_color(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_PRESSED, lv_color_hex(90 * 256 * 256 + 152 * 256 + 215));
  lv_obj_set_style_local_shadow_opa(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 255);
  lv_obj_set_style_local_shadow_width(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 40);
  lv_obj_set_style_local_shadow_spread(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 6);
  lv_obj_set_style_local_text_color(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DISABLED, lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
  lv_obj_set_style_local_text_opa(LabelWIFI, LV_BTN_PART_MAIN, LV_STATE_DISABLED, 255);
  lv_obj_align(LabelWIFI, Screen1, LV_ALIGN_CENTER, -138, 130); // force: 88
  lv_obj_set_event_cb(LabelWIFI, LabelWIFI_eventhandler);/*Assign an event function*/

  LabelPREF = lv_label_create(Screen1, NULL);/*-------------------------- LABEL PREF ----------------------------*/
  lv_label_set_long_mode(LabelPREF, LV_LABEL_LONG_CROP);
  lv_label_set_align(LabelPREF, LV_LABEL_ALIGN_CENTER);
  lv_label_set_text(LabelPREF, "PREF");
  lv_obj_set_size(LabelPREF, 88, 40);  // force: 138
  lv_obj_set_click(LabelPREF, true);
  lv_obj_set_hidden(LabelPREF, false);
  lv_obj_clear_state(LabelPREF, LV_STATE_DISABLED);
  lv_obj_set_drag(LabelPREF, false);
  lv_obj_set_style_local_text_color(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(255 * 256 * 256 + 255 * 256 + 255));
  lv_obj_set_style_local_text_opa(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 150);
  lv_obj_set_style_local_text_font(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_THEME_DEFAULT_FONT_SUBTITLE);
  lv_obj_set_style_local_bg_color(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(45 * 256 * 256 + 160 * 256 + 183));
  lv_obj_set_style_local_bg_opa(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_bg_grad_color(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(10 * 256 * 256 + 19 * 256 + 24));
  lv_obj_set_style_local_bg_main_stop(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 30);
  lv_obj_set_style_local_bg_grad_stop(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 128);
  lv_obj_set_style_local_radius(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 20);
  lv_obj_set_style_local_bg_grad_dir(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_GRAD_DIR_VER);
  lv_obj_set_style_local_border_color(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
  lv_obj_set_style_local_border_opa(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_border_width(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 1);
  lv_obj_set_style_local_border_side(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_BORDER_SIDE_FULL);
  lv_obj_set_style_local_shadow_color(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
  lv_obj_set_style_local_shadow_opa(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 200);
  lv_obj_set_style_local_shadow_width(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 40);
  lv_obj_set_style_local_shadow_spread(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 5);
  lv_obj_set_style_local_pad_left(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
  lv_obj_set_style_local_pad_right(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
  lv_obj_set_style_local_pad_top(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
  lv_obj_set_style_local_pad_bottom(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
  lv_obj_set_style_local_text_color(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_PRESSED, lv_color_hex(254 * 256 * 256 + 253 * 256 + 206));
  lv_obj_set_style_local_text_opa(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 255);
  lv_obj_set_style_local_shadow_color(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_PRESSED, lv_color_hex(90 * 256 * 256 + 152 * 256 + 215));
  lv_obj_set_style_local_shadow_opa(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 255);
  lv_obj_set_style_local_shadow_width(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 40);
  lv_obj_set_style_local_shadow_spread(LabelPREF, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 6);
  lv_obj_align(LabelPREF, Screen1, LV_ALIGN_CENTER, 138, 130); // force: 88
  lv_obj_set_event_cb(LabelPREF, LabelPREF_eventhandler);/*Assign an event function*/

  /*FONT_SMALL  montserrat_12      FONT_NORMAL montserrat_14    FONT_SUBTITLE montserrat_20   FONT_TITLE montserrat_24*/
  RollerSSID = lv_roller_create(Screen1, NULL);/*-------------------------- ROLLER SSID ----------------------------*/
  lv_roller_set_options(RollerSSID, "SSID", LV_ROLLER_MODE_NORMAL);
  lv_roller_set_anim_time(RollerSSID, 100);
  lv_roller_set_align(RollerSSID, LV_LABEL_ALIGN_CENTER);
  lv_obj_set_click(RollerSSID, true);
  lv_obj_set_hidden(RollerSSID, true);
  lv_obj_clear_state(RollerSSID, LV_STATE_DISABLED);
  lv_obj_set_drag(RollerSSID, false);
  lv_obj_align(RollerSSID, Screen1, LV_ALIGN_CENTER, 0, 0);
  lv_roller_set_visible_row_count(RollerSSID, 3);
  lv_obj_set_style_local_text_color(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, lv_color_hex(213 * 256 * 256 + 250 * 256 + 254));
  lv_obj_set_style_local_text_opa(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, 150);
  lv_obj_set_style_local_text_font(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, LV_THEME_DEFAULT_FONT_SMALL);
  lv_obj_set_style_local_bg_color(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, lv_color_hex(100 * 256 * 256 + 163 * 256 + 192));
  lv_obj_set_style_local_bg_opa(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_bg_grad_color(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, lv_color_hex(9 * 256 * 256 + 22 * 256 + 29));
  lv_obj_set_style_local_bg_main_stop(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, 0);
  lv_obj_set_style_local_bg_grad_stop(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, 600);
  lv_obj_set_style_local_radius(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, 16);
  lv_obj_set_style_local_bg_grad_dir(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, LV_GRAD_DIR_VER);
  lv_obj_set_style_local_border_color(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
  lv_obj_set_style_local_border_opa(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_border_width(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, 1);
  lv_obj_set_style_local_border_side(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, LV_BORDER_SIDE_FULL);
  lv_obj_set_style_local_shadow_color(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
  lv_obj_set_style_local_shadow_opa(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, 200);
  lv_obj_set_style_local_shadow_width(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, 30);
  lv_obj_set_style_local_shadow_spread(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, 5);
  lv_obj_set_style_local_text_color(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_CHECKED, lv_color_hex(213 * 256 * 256 + 250 * 256 + 254));
  lv_obj_set_style_local_text_opa(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_CHECKED, 255);
  lv_obj_set_style_local_text_font(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_DEFAULT, LV_THEME_DEFAULT_FONT_SMALL);
  lv_obj_set_style_local_text_color(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_PRESSED, lv_color_hex(213 * 256 * 256 + 250 * 256 + 254));
  lv_obj_set_style_local_text_opa(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_PRESSED, 255);
  lv_obj_set_style_local_text_font(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_PRESSED, LV_THEME_DEFAULT_FONT_SMALL);
  lv_obj_set_style_local_shadow_color(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_PRESSED, lv_color_hex(90 * 256 * 256 + 152 * 256 + 215));
  lv_obj_set_style_local_shadow_opa(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_PRESSED, 200);
  lv_obj_set_style_local_shadow_width(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_PRESSED, 40);
  lv_obj_set_style_local_shadow_spread(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_PRESSED, 8);
  lv_obj_set_style_local_text_color(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_CHECKED | LV_STATE_PRESSED, lv_color_hex(213 * 256 * 256 + 250 * 256 + 254));
  lv_obj_set_style_local_text_opa(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_CHECKED | LV_STATE_PRESSED, 255);
  lv_obj_set_style_local_text_font(RollerSSID, LV_ROLLER_PART_BG, LV_STATE_CHECKED | LV_STATE_PRESSED, LV_THEME_DEFAULT_FONT_SMALL);
  lv_obj_set_style_local_text_color(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, lv_color_hex(213 * 256 * 256 + 250 * 256 + 254));
  lv_obj_set_style_local_text_opa(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_text_font(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, LV_THEME_DEFAULT_FONT_NORMAL);
  lv_obj_set_style_local_bg_color(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, lv_color_hex(105 * 256 * 256 + 143 * 256 + 164));
  lv_obj_set_style_local_bg_opa(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_bg_grad_color(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, lv_color_hex(23 * 256 * 256 + 46 * 256 + 59));
  lv_obj_set_style_local_bg_main_stop(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, 0);
  lv_obj_set_style_local_bg_grad_stop(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, 128);
  lv_obj_set_style_local_radius(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, 8);
  lv_obj_set_style_local_bg_grad_dir(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, LV_GRAD_DIR_VER);
  lv_obj_set_style_local_shadow_color(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, lv_color_hex(3 * 256 * 256 + 17 * 256 + 24));
  lv_obj_set_style_local_shadow_opa(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_shadow_width(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, 60);
  lv_obj_set_style_local_shadow_spread(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_DEFAULT, 8);
  lv_obj_set_style_local_text_color(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_CHECKED, lv_color_hex(213 * 256 * 256 + 250 * 256 + 254));
  lv_obj_set_style_local_text_opa(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_CHECKED, 255);
  lv_obj_set_style_local_text_color(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_PRESSED, lv_color_hex(213 * 256 * 256 + 250 * 256 + 254));
  lv_obj_set_style_local_text_opa(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_PRESSED, 255);
  lv_obj_set_style_local_text_font(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_PRESSED, LV_THEME_DEFAULT_FONT_NORMAL);
  lv_obj_set_style_local_text_color(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_CHECKED | LV_STATE_PRESSED, lv_color_hex(213 * 256 * 256 + 250 * 256 + 254));
  lv_obj_set_style_local_text_opa(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_CHECKED | LV_STATE_PRESSED, 255);
  lv_obj_set_style_local_text_font(RollerSSID, LV_ROLLER_PART_SELECTED, LV_STATE_CHECKED | LV_STATE_PRESSED, LV_THEME_DEFAULT_FONT_NORMAL);
  lv_roller_set_auto_fit(RollerSSID, true);
  lv_obj_set_event_cb(RollerSSID, RollerSSID_eventhandler);

  /*FONT_SMALL  montserrat_12      FONT_NORMAL montserrat_14    FONT_SUBTITLE montserrat_20   FONT_TITLE montserrat_24*/
  LabelSSID = lv_label_create(Screen1, NULL);/*-------------------------- LABEL SSID ----------------------------*/
  lv_label_set_long_mode(LabelSSID, LV_LABEL_LONG_EXPAND);
  lv_label_set_align(LabelSSID, LV_LABEL_ALIGN_CENTER);
  lv_label_set_text(LabelSSID, "SSID");
  lv_obj_set_size(LabelSSID, 58, 38);  // force: -138
  lv_obj_set_click(LabelSSID, true);
  lv_obj_set_hidden(LabelSSID, true);
  lv_obj_clear_state(LabelSSID, LV_STATE_DISABLED);
  lv_obj_set_drag(LabelSSID, false);
  lv_obj_set_style_local_text_color(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(213 * 256 * 256 + 250 * 256 + 254));
  lv_obj_set_style_local_text_opa(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_text_font(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_THEME_DEFAULT_FONT_NORMAL);
  lv_obj_set_style_local_bg_color(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(45 * 256 * 256 + 160 * 256 + 183));
  lv_obj_set_style_local_bg_opa(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_bg_grad_color(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(10 * 256 * 256 + 19 * 256 + 24));
  lv_obj_set_style_local_bg_main_stop(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 0);
  lv_obj_set_style_local_bg_grad_stop(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 128);
  lv_obj_set_style_local_radius(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 20);
  lv_obj_set_style_local_bg_grad_dir(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_GRAD_DIR_VER);
  lv_obj_set_style_local_border_color(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
  lv_obj_set_style_local_border_opa(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_border_width(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 1);
  lv_obj_set_style_local_border_side(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_BORDER_SIDE_FULL);
  lv_obj_set_style_local_shadow_color(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
  lv_obj_set_style_local_shadow_opa(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 200);
  lv_obj_set_style_local_shadow_width(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 40);
  lv_obj_set_style_local_shadow_spread(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 5);
  lv_obj_set_style_local_pad_left(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 20);
  lv_obj_set_style_local_pad_right(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 20);
  lv_obj_set_style_local_pad_top(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
  lv_obj_set_style_local_pad_bottom(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
  lv_obj_set_style_local_text_color(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_PRESSED, lv_color_hex(167 * 256 * 256 + 167 * 256 + 255));
  lv_obj_set_style_local_text_opa(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 255);
  lv_obj_set_style_local_shadow_color(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_PRESSED, lv_color_hex(90 * 256 * 256 + 152 * 256 + 215));
  lv_obj_set_style_local_shadow_opa(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 255);
  lv_obj_set_style_local_shadow_width(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 40);
  lv_obj_set_style_local_shadow_spread(LabelSSID, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 8);
  lv_obj_align(LabelSSID, Screen1, LV_ALIGN_CENTER, -138, -90); // force: 58

  /*FONT_SMALL  montserrat_12      FONT_NORMAL montserrat_14    FONT_SUBTITLE montserrat_20   FONT_TITLE montserrat_24*/
  LabelPASSW = lv_label_create(Screen1, NULL);/*-------------------------- LABEL PASSW ----------------------------*/
  lv_label_set_long_mode(LabelPASSW, LV_LABEL_LONG_EXPAND);
  lv_label_set_align(LabelPASSW, LV_LABEL_ALIGN_CENTER);
  lv_label_set_text(LabelPASSW, "PASSW");
  lv_obj_set_size(LabelPASSW, 81, 38);  // force: -138
  lv_obj_set_click(LabelPASSW, true);
  lv_obj_set_hidden(LabelPASSW, true);
  lv_obj_clear_state(LabelPASSW, LV_STATE_DISABLED);
  lv_obj_set_drag(LabelPASSW, false);
  lv_obj_set_style_local_text_color(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(213 * 256 * 256 + 250 * 256 + 254));
  lv_obj_set_style_local_text_opa(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_text_font(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_THEME_DEFAULT_FONT_NORMAL);
  lv_obj_set_style_local_bg_color(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(45 * 256 * 256 + 160 * 256 + 183));
  lv_obj_set_style_local_bg_opa(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_bg_grad_color(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(10 * 256 * 256 + 19 * 256 + 24));
  lv_obj_set_style_local_bg_main_stop(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 30);
  lv_obj_set_style_local_bg_grad_stop(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 128);
  lv_obj_set_style_local_radius(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 20);
  lv_obj_set_style_local_bg_grad_dir(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_GRAD_DIR_VER);
  lv_obj_set_style_local_border_color(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
  lv_obj_set_style_local_border_opa(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 255);
  lv_obj_set_style_local_border_width(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 1);
  lv_obj_set_style_local_border_side(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, LV_BORDER_SIDE_FULL);
  lv_obj_set_style_local_shadow_color(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, lv_color_hex(0 * 256 * 256 + 0 * 256 + 0));
  lv_obj_set_style_local_shadow_opa(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 200);
  lv_obj_set_style_local_shadow_width(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 40);
  lv_obj_set_style_local_shadow_spread(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 5);
  lv_obj_set_style_local_pad_left(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 20);
  lv_obj_set_style_local_pad_right(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 20);
  lv_obj_set_style_local_pad_top(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
  lv_obj_set_style_local_pad_bottom(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_DEFAULT, 10);
  lv_obj_set_style_local_text_color(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_PRESSED, lv_color_hex(167 * 256 * 256 + 167 * 256 + 255));
  lv_obj_set_style_local_text_opa(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 255);
  lv_obj_set_style_local_shadow_color(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_PRESSED, lv_color_hex(90 * 256 * 256 + 152 * 256 + 215));
  lv_obj_set_style_local_shadow_opa(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 255);
  lv_obj_set_style_local_shadow_width(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 40);
  lv_obj_set_style_local_shadow_spread(LabelPASSW, LV_BTN_PART_MAIN, LV_STATE_PRESSED, 8);
  lv_obj_align(LabelPASSW, Screen1, LV_ALIGN_CENTER, -138, -40); // force: 81
  lv_obj_set_event_cb(LabelPASSW, LabelPASSW_eventhandler);

  lv_style_init(&style_kb);/*Create a STYLE for keyboard */
  lv_style_set_bg_color(&style_kb, LV_STATE_DEFAULT, lv_color_hex(45 * 256 * 256 + 160 * 256 + 183));
   lv_style_set_bg_grad_color(&style_kb, LV_STATE_DEFAULT,lv_color_hex(10 * 256 * 256 + 19 * 256 + 24));
   lv_style_set_bg_grad_stop(&style_kb, LV_STATE_DEFAULT, 128);   
  lv_style_set_bg_grad_dir(&style_kb,  LV_STATE_DEFAULT, LV_GRAD_DIR_VER);
  lv_style_set_text_color(&style_kb, LV_STATE_DEFAULT, LV_COLOR_WHITE);
  lv_style_set_radius(&style_kb, LV_STATE_DEFAULT, 8);
 // lv_style_set_bg_opa(&style_kb, LV_BTN_STATE_PRESSED, LV_OPA_50);
    lv_style_set_bg_color(&style_kb, LV_BTN_STATE_PRESSED,lv_color_hex(90 * 256 * 256 + 152 * 256 + 215));

  /*Create a text area and keyboard */
  kb_ta  = lv_textarea_create(Screen1, NULL);
  lv_obj_set_size(kb_ta, screenWidth / 3, 30);
  lv_textarea_set_one_line(kb_ta, true);
  lv_textarea_set_text_align(kb_ta, LV_LABEL_ALIGN_CENTER);
  lv_obj_align(kb_ta, NULL, LV_ALIGN_CENTER, 0, -20);
  lv_textarea_set_text(kb_ta, "");
  kb = lv_keyboard_create(Screen1, NULL);
  lv_obj_add_style(kb, LV_KEYBOARD_PART_BG, &style_kb);
  lv_obj_add_style(kb, LV_KEYBOARD_PART_BTN, &style_kb);
  lv_obj_set_size(kb,  screenWidth, screenHeight / 2);
  lv_obj_set_pos(kb, 0, 160);
  lv_keyboard_set_cursor_manage(kb, true);
  lv_obj_set_event_cb(kb, keyboard_event_cb);
  lv_keyboard_set_textarea(kb, kb_ta);
  lv_obj_set_hidden(kb_ta, true);
  lv_obj_set_hidden(kb, true);

  ledcWrite(0, 128); // Start @ initial Brightnes
  listDir(SPIFFS, "/", 0);
}
/*   -------------------    END SETUP               END SETUP                     END SETUP                  END SETUP  ---------------------*/

void loop() {/*   ======================      START LOOP     START LOOP     START LOOP     START LOOP       =======================*/
  /* xSemaphoreTake(xSemaphore, portMAX_DELAY);
    while (1) {
    lv_task_handler();
    delay(5);
    }
    xSemaphoreGive(xSemaphore);
    delay(5);*/
  while (1) {
    lv_task_handler();
    if (Serial.available() > 0) {
      // Read the command byte
      command = Serial.readStringUntil('\n');
      command.trim();// elimina LF e CR
      // Serial.print("String received "); Serial.println(command);
      char commandChar = command.charAt(0);
      switch (commandChar) {
        case '1' : { /* ---------- SCREENSHOT -------- */
            long posizione = command.indexOf("/");
            if (posizione != -1) {
              String nome = command.substring(posizione);
              int lung = nome.length();
              char Buf [lung + 1];
              nome.toCharArray(Buf, lung + 1);
              BytesWrites = 0;
              guiTakeScreenshot(SPIFFS, Buf);
            } else {
              Serial.println("/ char missed");
            }
          }
        case '2' : { /* ---------- DIRECTORY -------- */
            listDir(SPIFFS, "/", 0);
            break;
          }
        case '3': {/* ---------- WRITE FILE BINARY TO HEX-------- */
            long posizione = command.indexOf("/");
            if (posizione != -1) {
              String nome = command.substring(posizione);
              int lung = nome.length();
              char Buf [lung + 1];
              nome.toCharArray(Buf, lung + 1);
              readFileH(SPIFFS, Buf);
            } else {
              Serial.println("/ char missed");
            }
            break;
          }
        case '4' : {/* ---------- ERASE-------- */
            long posizione = command.indexOf("/");
            if (posizione != -1) {
              String nome = command.substring(posizione);
              int lung = nome.length();
              char Buf [lung + 1];
              nome.toCharArray(Buf, lung + 1);
              deleteFile(SPIFFS, Buf);
            } else {
              Serial.println("/ char missed");
            }
            break;
          }
        case '5' : { /* ---------- FORMAT-------- */
            formatto();
            break;
          }
        case 't': {/* ---------- WRITE FILE TO SERIAL -------- */
            long posizione = command.indexOf("/");
            if (posizione != -1) {
              String nome = command.substring(posizione);
              int lung = nome.length();
              char Buf [lung + 1];
              nome.toCharArray(Buf, lung + 1);
              readFile(SPIFFS, Buf);
            } else {
              Serial.println("/ char missed");
            }
            break;
          }
        default:
          Serial.println("Command not recognized");
          break;
      }
    }
  }
}/*   ----------------------------------------------- END LOOP     END LOOP      END LOOP      END LOOP        END LOOP  -----------------------------------------------*/
/* -----------  UPDATE PASSWORD  --------------*/
static void updatePassw( String msg) {
  //msg.trim();
  Serial.println(msg);
  if (msg.length() > 0) {
    T = msg;
    TT[(T.length() + 1)];
    T.toCharArray(TT, T.length() + 1);
    /* Serial.println((String)T.length());*/
    lv_label_set_text(LabelPASSW, TT); lv_obj_align(LabelPASSW, Screen1, LV_ALIGN_CENTER, -138, -40); lv_label_refr_text(LabelPASSW);
    lv_label_set_text(LabelToast, "PRESS PASSW button for connect"); lv_obj_align(LabelToast, Screen1, LV_ALIGN_IN_TOP_MID, 0, 10); lv_label_refr_text(LabelToast);
  }
}
/* ========================  SCREENSHOT  =========================*/
void guiTakeScreenshot(fs::FS & fs, const char * pFileName) {
  gui_get_bitmap_header(BMPHeader, sizeof(BMPHeader));
  pFileOut = fs.open(pFileName, "wb"); // 1. Open a stream for writing
  /*SPIFFS open function needs path and mode:  mode = "r", "w", "a", "r+", "w+", "a+" (text file) or "rb", "wb", "ab", "rb+", "wb+", "ab+" (binary)
    where r = read, w = write, a = append   + means file is open for update (read and write)   b means the file os open for binary operations*/
  if (pFileOut) {
    size_t len = pFileOut.write(BMPHeader, 122);
    if (len != 122) {
      Serial.println("Fail to write BMP header...abort");
      return;
    }
    /* Write a 122 bytes BMP fileheader, describing the pixelformat */
    Serial.println(F("BMP Header written"));
    /*  Temporarily swap the flush_cb*/
    /* Get current callback */
    lv_disp_t * disp_drv = lv_disp_get_default();
    void (*flush_cb)(struct _disp_drv_t * disp_drv, const lv_area_t * area, lv_color_t * color_p);
    flush_cb = disp_drv->driver.flush_cb; /* store callback */
    /* Set the screenshot callback */
    disp_drv->driver.flush_cb = gui_screenshot_to_file;
    /* 4. Refresh screen to call the screenshot callback */
    lv_obj_invalidate(lv_scr_act());
    /* 5. Captures the refreshes to the stream, also also update the tft */
    lv_refr_now(NULL);
    /* 6. Restore callback */
    disp_drv->driver.flush_cb = flush_cb; /* restore callback */
    Serial.print("Bitmap data flushed to "); Serial.println(pFileName);
    pFileOut.close(); // 7. Close file
    Serial.println("==========   END SCREENSHOT   =============");
    Serial.print("Writes Tot= "); Serial.print(BytesWrites); Serial.print("  + 122 bytes of BMP header = "); Serial.println((BytesWrites + 122));
    Serial.print(screenWidth); Serial.print("x"); Serial.print(screenHeight); Serial.print(" * 2 = "); Serial.println((screenWidth * screenHeight * 2));
  } else {
    Serial.print("cannot write "); Serial.println(pFileName);
  }
}
/* Flush VDB bytes to a file  */
static void gui_screenshot_to_file(lv_disp_drv_t * disp, const lv_area_t * area, lv_color_t * color_p) {
  size_t len = (area->x2 - area->x1 + 1) * (area->y2 - area->y1 + 1); /* Number of pixels */
  len *= sizeof(lv_color_t);
  int aaa = 0;/* how many bytes is written actually*/
  while (aaa < len) {/* if the number of bytes written on SPIFFS is equal to the number of bytes of the buffer it exits the cycle */
    size_t res = pFileOut.write((uint8_t *)color_p + aaa , len - aaa);
    aaa = aaa + res;    BytesWrites = BytesWrites + res;
    if (len != aaa) Serial.println("  retry write on SPIFFS");
    /* Serial.print(aaa); Serial.print("     SIZE of buffer = "); Serial.print(len); Serial.print("   Writes Now= ");
      Serial.print(res); Serial.print("   Writes Tot= "); Serial.println(BytesWrites);*/
    delay(0);
  }
  Serial.println("Flush...");
  my_disp_flush(disp, area, color_p);
}
static void gui_get_bitmap_header(uint8_t * buffer1, size_t bufsize) { /* ========== BMP HEADER  =========*/
  //memset(buffer1, 0, bufsize);
  //lv_disp_t * disp = lv_disp_get_default();
  buffer1[0]        = 0x42; // B
  buffer1[1]        = 0x4D; // M
  buffer1[10 + 0] = 122;      // full header size
  buffer1[14 + 0] = 122 - 14; // dib header size
  buffer1[26 + 0] = 1;        // number of color planes
  buffer1[28 + 0] = 16;       // or 24, bbp
  buffer1[30 + 0] = 3;        // compression, 0 = RGB / 3 = RGBA
  // file size
  guiSetBmpHeader(&buffer1[2], 122 + screenWidth * screenHeight * buffer1[28] / 8);
  // horizontal resolution
  guiSetBmpHeader(&buffer1[18], screenWidth);
  // vertical resolution
  guiSetBmpHeader(&buffer1[22], -screenHeight);
  // bitmap size
  guiSetBmpHeader(&buffer1[34], screenWidth * screenHeight * buffer1[28 + 0] / 8);
  // horizontal pixels per meter
  guiSetBmpHeader(&buffer1[38], 2836);
  // vertical pixels per meter
  guiSetBmpHeader(&buffer1[42], 2836);
  // R: 1111 1000 | 0000 0000
  guiSetBmpHeader(&buffer1[54], 0xF800); // Red bitmask
  // G: 0000 0111 | 1110 0000
  guiSetBmpHeader(&buffer1[58], 0x07E0); // Green bitmask
  // B: 0000 0000 | 0001 1111
  guiSetBmpHeader(&buffer1[62], 0x001F); // Blue bitmask
  // A: 0000 0000 | 0000 0000
  guiSetBmpHeader(&buffer1[66], 0x0000); // No Aplpha Mask
  // "Win
  buffer1[70 + 3] = 0x57;
  buffer1[70 + 2] = 0x69;
  buffer1[70 + 1] = 0x6E;
  buffer1[70 + 0] = 0x20;
}
static void guiSetBmpHeader(uint8_t * buffer_p, int32_t data) {
  *buffer_p++ = data & 0xFF;
  *buffer_p++ = (data >> 8) & 0xFF;
  *buffer_p++ = (data >> 16) & 0xFF;
  *buffer_p++ = (data >> 24) & 0xFF;
}
/* ----------------------------------  END SCREENSHOT  ----------------------------*/

/* ========================  SERIAL COMMANDS  =========================*/
void listDir(fs::FS & fs, const char * dirname, uint8_t levels) {/* LIST DIRECTORY */
  unsigned int totalBytes = SPIFFS.totalBytes();
  unsigned int usedBytes = SPIFFS.usedBytes();
  unsigned int availBytes = totalBytes - usedBytes;
  String  T = "\n===== SPIFFS SYSTEM INFO =====";
  T += "\nTotal space:   "; T += String(totalBytes); T += " bytes";
  T += "\nUsed space:  "; T += String( usedBytes); T += " bytes";
  T += "\nFREE SPACE:  "; T += String (availBytes); T += " bytes";
  char TT[(T.length() + 1)];
  T.toCharArray(TT, T.length() + 1);
  lv_label_set_text(LabelToast, "Info Text Label   click for close"); lv_label_refr_text(LabelToast);
  // lv_label_set_text(LabelToast,  lv_label_get_text(LabelToast) & TT);
  lv_label_ins_text(LabelToast, LV_LABEL_POS_LAST, TT);
  lv_obj_align(LabelToast, Screen1, LV_ALIGN_IN_TOP_MID, 0, 10);
  lv_obj_set_hidden(LabelToast, false); lv_label_refr_text(LabelToast);
  Serial.println(T);
  //  Serial.println("===== FILE SYSTEM INFO =====");
  //  Serial.print("Total space:      ");  Serial.print(totalBytes);  Serial.println(" byte");
  //  Serial.print("Total space used: ");  Serial.print(usedBytes);  Serial.println(" byte");
  //  Serial.print("FREE SPACE  :      ");  Serial.print(availBytes);  Serial.println(" byte");
  Serial.println();
  T = "\n>>>> LISTING DIRECTORY <<<";
  Serial.printf(">>>>> LISTING DIRECTORY: %s\r\n", dirname);
  File root = fs.open(dirname);
  if (!root) {
    Serial.println("− failed to open directory");
    return;
  }
  if (!root.isDirectory()) {
    Serial.println(" − not a directory");
    return;
  }
  File file = root.openNextFile();
  while (file) {
    if (file.isDirectory()) {
      Serial.print("  DIR : ");
      Serial.println(file.name());
      if (levels) {
        listDir(fs, file.name(), levels - 1);
      }
    } else {
      T += "\n>>>  FILE: "; T += String( file.name()); T += " Size: "; T += String( file.size());
      Serial.print(">>>>>  FILE: ");
      Serial.print(file.name());
      Serial.print("\tSIZE: ");
      Serial.println(file.size());
    }
    file = root.openNextFile();
  }
  file.close();
  TT[(T.length() + 1)]; T.toCharArray(TT, T.length() + 1);
  lv_label_ins_text(LabelToast, LV_LABEL_POS_LAST, TT);
  lv_obj_align(LabelToast, Screen1, LV_ALIGN_IN_TOP_MID, 0, 10); lv_label_refr_text(LabelToast);
  Comandi();
}
/* ----------- READ FILE BINARY TO HEX----------*/
void readFileH(fs::FS & fs, const char * path) {
  size_t len = 0;
  size_t i = 0;
  Serial.printf("Reading file: %s\r\n", path);
  File file = fs.open(path, "rb");
  file.setTimeout(0);
  if (file && !file.isDirectory()) {
    len = file.size();
    size_t flen = len;
    Serial.println("- reading" );
    uint32_t sstart = millis();
    uint32_t eend = sstart;
    for (i = 0; i < len; i++) {
      incomingByte = file.read();
      if ( incomingByte < 16) {/* need put a 0 more or we get a 5 and not a 05 in hex result when byte is from 0 to 15*/
        Serial.print("0");
      }
      Serial.print(incomingByte, HEX);
    }
    eend = millis() - sstart;
    Serial.println(""); Serial.println("");
    file.close();
    Serial.printf("- %u bytes read in %u ms\r\n", flen, eend);
    Serial.println("----- FINISH -----");
  } else {
    Serial.println("- failed to open file for reading");
  }
}
void readFile(fs::FS & fs, const char * path) {/* ----------- READ FILE BINARY AND WRITE TO SERIAL----------*/
  File file = fs.open(path, "rb");/* read binary mode */
  file.setTimeout(0);
  if (file && !file.isDirectory()) {
    size_t len = file.size();
    for (int i = 0; i < len; i++) {
      incomingByte = file.read();
      Serial.write(incomingByte);
    }
    file.close();
  } else {
    Serial.println("- failed to open file for reading");
  }
}
/* ----------- DELETE FILE  ----------*/
void deleteFile(fs::FS & fs, const char * path) {
  Serial.printf("Deleting file: %s\r\n", path);
  Serial.println(">>>" + (String) path + "<<<");
  if (fs.remove(path)) {
    Serial.println("− file deleted");
  } else {
    Serial.println("− delete failed");
  }
}
/* ----------- FORMAT  ----------*/
void formatto() {
  Serial.println("Formatto SPIFF");
  SPIFFS.format();
  SPIFFS.begin();
  Serial.println("SPIFF FORMATTATO");
}
void Comandi() {
  Serial.println("");
  Serial.println("========== LIST OF COMMANDS ==========");
  Serial.println("1 /name   << Save Screenshot to SPIFF (example: 1 /shot.bmp)");
  Serial.println("2         << Read Directory List of SPIFF");
  Serial.println("3 /name   << Read file Binary TO HEX   (example: 3 /Pippo/shot.bmp and put HEX data output to serial monitor)");
  Serial.println("4 /name   << Delete file  (example: 4 /shot.bmp' for delete file shot.bmp)");
  Serial.println("5         << Format SPIFF and erase all content");
  Serial.println("t /name   << Send file from SPIFFS to serial in binary mode for capture with Realterm(need close serial monitor)");
  Serial.println("======================================");
}/* ----------------------------------  END SERIAL COMMANDS  ----------------------------*/
//void printEvent(String Event, lv_event_t event) {
//  Serial.print(Event);
//  printf(" ");
//  switch (event) {
//    case LV_EVENT_PRESSED:
//      printf("Pressed\n");
//      break;
//    case LV_EVENT_SHORT_CLICKED:
//      printf("Short clicked\n");
//      break;
//    case LV_EVENT_CLICKED:
//      printf("Clicked\n");
//      break;
//    case LV_EVENT_LONG_PRESSED:
//      printf("Long press\n");
//      break;
//    case LV_EVENT_LONG_PRESSED_REPEAT:
//      printf("Long press repeat\n");
//      break;
//    case LV_EVENT_RELEASED:
//      printf("Released\n");
//      break;
//  }
//}
